.\"
.\" Copyright (C) 2001 Chad David <davidc@acns.ab.ca>. All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice(s), this list of conditions and the following disclaimer as
.\"    the first lines of this file unmodified other than the possible
.\"    addition of one or more copyright notices.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice(s), this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER(S) ``AS IS'' AND ANY
.\" EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDER(S) BE LIABLE FOR ANY
.\" DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
.\" CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
.\" DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/vhold.9,v 1.4 2005/07/22 00:28:22 rodrigc Exp $
.\" $DragonFly: src/share/man/man9/vhold.9,v 1.4 2007/05/11 08:25:24 swildner Exp $
.\"
.Dd May 5, 2007
.Dt VHOLD 9
.Os
.Sh NAME
.Nm vhold , vdrop
.Nd "Acquire/release an auxiliary reference on a vnode"
.Sh SYNOPSIS
.In sys/param.h
.In sys/vnode.h
.Ft void
.Fn vhold "struct vnode *vp"
.Ft void
.Fn vdrop "struct vnode *vp"
.Sh DESCRIPTION
The
.Fn vhold
function acquires an auxiliary reference on a vnode by incrementing the
.Fa v_auxrefs
field.
Auxiliary references do not reactivate a vnode or move it to the cache
if it resides on the free list, but they will prevent the vnode from
being recycled (if not already being recycled), or reused.
Auxiliary references are used to associate auxiliary structures such as
namecache records with the vnode for those cases where the intent is to
not allow the vnode to be immediately recycled.
Auxiliary references are also used to access a vnode via an auxiliary
structure without having to hold a deep stack of locks that might
create deadlock issues for the caller.
.Pp
The
.Fn vdrop
function decrements the
.Fa v_auxrefs
field.  If the vnode has been deactivated and resides in the cache,
it will be moved to the free list when
.Fa v_auxrefs
drops to 0.
.Sh SEE ALSO
.Xr vnode 9 ,
.Xr vn_lock 9 ,
.Xr vn_unlock 9 ,
.Xr vget 9 ,
.Xr vput 9 ,
.Xr vref 9 ,
.Xr vrele 9
.Sh AUTHORS
This manual page was written by
.An Chad David Aq davidc@acns.ab.ca .
